class AmmoRifles extends CSSAmmo;

#exec MESH MODELIMPORT MESH=CSSRifleAmmo MODELFILE=Models\AmmoParts\CSSRifleAmmoMesh.psk
#exec MESH ORIGIN MESH=CSSRifleAmmo X=0 Y=0 Z=-0.5 YAW=0 PITCH=0 ROLL=0

#exec ANIM IMPORT ANIM=CSSRifleAmmoAnims ANIMFILE=Models\AmmoParts\CSSRifleAmmoMeshAnims.psa COMPRESS=1

#exec ANIM SEQUENCE ANIM=CSSRifleAmmoAnims SEQ=All STARTFRAME=0 NUMFRAMES=1
#exec ANIM SEQUENCE ANIM=CSSRifleAmmoAnims SEQ=Still STARTFRAME=0 NUMFRAMES=1

#exec ANIM DIGEST ANIM=CSSRifleAmmoAnims
#exec MESH DEFAULTANIM MESH=CSSRifleAmmo ANIM=CSSRifleAmmoAnims

#exec MESHMAP SCALE MESHMAP=CSSRifleAmmo X=1.0 Y=1.0 Z=1.0

#exec TEXTURE IMPORT NAME=RifleAmmo FILE=Textures\AmmoParts\RifleAmmo.bmp GROUP=AmmoParts LODSET=2
#exec MESHMAP SETTEXTURE MESHMAP=CSSRifleAmmo NUM=0 TEXTURE=RifleAmmo

defaultproperties
{
     AmmoAmount=30
     MaxAmmo=400
     UsedInWeaponSlot(5)=1
     UsedInWeaponSlot(6)=1
     UsedInWeaponSlot(7)=1
     PickupMessage="You picked up 30 Assault Rifle Rounds."
     PickupViewMesh=SkeletalMesh'CSSWeaponsv1_1.CSSRifleAmmo'
     PickupViewScale=4.100000
     MaxDesireability=0.300000
     Physics=PHYS_Falling
     LODBias=20.000000
     Mesh=SkeletalMesh'CSSWeaponsv1_1.CSSRifleAmmo'
     DrawScale=4.100000
     CollisionRadius=32.000000
     CollisionHeight=8.000000
     bCollideActors=True
     RotationRate=(Yaw=0)
}