class AmmoSMG extends CSSAmmo;

#exec MESH MODELIMPORT MESH=CSSSMGAmmo MODELFILE=Models\AmmoParts\CSSSMGAmmoMesh.psk
#exec MESH ORIGIN MESH=CSSSMGAmmo X=0 Y=0 Z=-0.5 YAW=0 PITCH=0 ROLL=0

#exec ANIM IMPORT ANIM=CSSSMGAmmoAnims ANIMFILE=Models\AmmoParts\CSSSMGAmmoMeshAnims.psa COMPRESS=1

#exec ANIM SEQUENCE ANIM=CSSSMGAmmoAnims SEQ=All STARTFRAME=0 NUMFRAMES=1
#exec ANIM SEQUENCE ANIM=CSSSMGAmmoAnims SEQ=Still STARTFRAME=0 NUMFRAMES=1

#exec ANIM DIGEST ANIM=CSSSMGAmmoAnims
#exec MESH DEFAULTANIM MESH=CSSSMGAmmo ANIM=CSSSMGAmmoAnims

#exec MESHMAP SCALE MESHMAP=CSSSMGAmmo X=1.0 Y=1.0 Z=1.0

#exec TEXTURE IMPORT NAME=SMGAmmo FILE=Textures\AmmoParts\SMGAmmo.bmp GROUP=AmmoParts LODSET=2
#exec MESHMAP SETTEXTURE MESHMAP=CSSSMGAmmo NUM=0 TEXTURE=SMGAmmo

defaultproperties
{
     AmmoAmount=30
     MaxAmmo=300
     UsedInWeaponSlot(4)=1
     PickupMessage="You picked up 30 SMG Rounds."
     PickupViewMesh=SkeletalMesh'CSSWeaponsv1_1.CSSSMGAmmo'
     PickupViewScale=4.000000
     MaxDesireability=0.300000
     Physics=PHYS_Falling
     LODBias=20.000000
     Mesh=SkeletalMesh'CSSWeaponsv1_1.CSSSMGAmmo'
     DrawScale=4.000000
     CollisionRadius=32.000000
     CollisionHeight=8.000000
     bCollideActors=True
     RotationRate=(Yaw=0)
}