class AmmoSniper extends CSSAmmo;

#exec MESH MODELIMPORT MESH=CSSSniperAmmo MODELFILE=Models\AmmoParts\CSSSniperAmmoMesh.psk
#exec MESH ORIGIN MESH=CSSSniperAmmo X=0 Y=0 Z=0.5 YAW=64 PITCH=0 ROLL=0

#exec ANIM IMPORT ANIM=CSSSniperAmmoAnims ANIMFILE=Models\AmmoParts\CSSSniperAmmoMeshAnims.psa COMPRESS=1

#exec ANIM SEQUENCE ANIM=CSSSniperAmmoAnims SEQ=All STARTFRAME=0 NUMFRAMES=1
#exec ANIM SEQUENCE ANIM=CSSSniperAmmoAnims SEQ=Still STARTFRAME=0 NUMFRAMES=1

#exec ANIM DIGEST ANIM=CSSSniperAmmoAnims
#exec MESH DEFAULTANIM MESH=CSSSniperAmmo ANIM=CSSSniperAmmoAnims

#exec MESHMAP SCALE MESHMAP=CSSSniperAmmo X=1.0 Y=1.0 Z=1.0

#exec TEXTURE IMPORT NAME=SniperAmmo FILE=Textures\AmmoParts\SnipAmmo.bmp GROUP=AmmoParts LODSET=2
#exec MESHMAP SETTEXTURE MESHMAP=CSSSniperAmmo NUM=0 TEXTURE=SniperAmmo

defaultproperties
{
     AmmoAmount=10
     MaxAmmo=40
     UsedInWeaponSlot(9)=1
     PickupMessage="You picked up 10 Sniper Rounds."
     PickupViewMesh=SkeletalMesh'CSSWeaponsv1_1.CSSSniperAmmo'
     PickupViewScale=4.000000
     MaxDesireability=0.300000
     Physics=PHYS_Falling
     LODBias=20.000000
     Mesh=SkeletalMesh'CSSWeaponsv1_1.CSSSniperAmmo'
     DrawScale=4.000000
     CollisionRadius=32.000000
     CollisionHeight=8.000000
     bCollideActors=True
     RotationRate=(Yaw=0)
}