class CSSShellCase extends BaseShellCase;

#exec MESH IMPORT MESH=CSSShellCase ANIVFILE=MODELS\EjectingShells\ShellCases\CSSShellCase_a.3d DATAFILE=MODELS\EjectingShells\ShellCases\CSSShellCase_d.3d X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=CSSShellCase X=0 Y=0 Z=0

#exec MESH SEQUENCE MESH=CSSShellCase SEQ=All STARTFRAME=0 NUMFRAMES=1
#exec MESH SEQUENCE MESH=CSSShellCase SEQ=Still STARTFRAME=0 NUMFRAMES=1

#exec MESHMAP NEW MESHMAP=CSSShellCase MESH=CSSShellCase
#exec MESHMAP SCALE MESHMAP=CSSShellCase X=0.1 Y=0.1 Z=0.2

#exec TEXTURE IMPORT NAME=CSSShellCase1 FILE=Textures\EjectingShells\ShellCases\cssbullet1.bmp GROUP=ShellCases LODSET=2
#exec MESHMAP SETTEXTURE MESHMAP=CSSShellCase NUM=1 TEXTURE=CSSShellCase1

defaultproperties
{
     MaxSpeed=1000.000000
     bNetOptional=True
     bReplicateInstigator=False
     Physics=PHYS_Falling
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=3.000000
     Mesh=LodMesh'CSSWeaponsv1_1.CSSShellCase'
     bUnlit=False
     AmbientGlow=64
     LODBias=20.000000
     bCollideActors=False
     bBounce=True
     bFixedRotationDir=True
     NetPriority=1.400000
}
