class Grenade_SmokeEffectA extends Grenade_FragSmoke;

#exec AUDIO IMPORT NAME="GrenadeSmokeExplode" FILE=Sounds\Grenades\GrenadeSmoke\SmokeExplode.wav GROUP="GrenadeSmoke"

simulated function PostBeginPlay()
{
	MakeSound();
}

simulated function BeginPlay()
{
	Velocity = Vect(0,1,1) * 350.00;
}

simulated function Tick( float DeltaTime)
{
    ScaleGlow = 2 * LifeSpan;
   	DrawScale += 0.001;
}

function MakeSound()
{
    PlaySound(EffectSound1,,3.0,,2200);
}

defaultproperties
{
	EffectSound1=Sound'CSSWeaponsv1_1.GrenadeSmoke.GrenadeSmokeExplode'
    RemoteRole=ROLE_SimulatedProxy
    LifeSpan=30.00
    DrawType=DT_Sprite
    Style=STY_Translucent
    Texture=Texture'CSSWeaponsv1_1.SmokeEffects.SmokeTex'
    DrawScale=0.00
    ScaleGlow=4.00
    AmbientGlow=0
    bParticles=False
}