class AmmoMachine extends CSSAmmo;

#exec MESH MODELIMPORT MESH=CSSMGAmmo MODELFILE=Models\AmmoParts\CSSMGAmmoMesh.psk
#exec MESH ORIGIN MESH=CSSMGAmmo X=0 Y=0 Z=0 YAW=0 PITCH=0 ROLL=0

#exec ANIM IMPORT ANIM=CSSMGAmmoAnims ANIMFILE=Models\AmmoParts\CSSMGAmmoMeshAnims.psa COMPRESS=1

#exec ANIM SEQUENCE ANIM=CSSMGAmmoAnims SEQ=All STARTFRAME=0 NUMFRAMES=1
#exec ANIM SEQUENCE ANIM=CSSMGAmmoAnims SEQ=Still STARTFRAME=0 NUMFRAMES=1

#exec ANIM DIGEST ANIM=CSSMGAmmoAnims
#exec MESH DEFAULTANIM MESH=CSSMGAmmo ANIM=CSSMGAmmoAnims

#exec MESHMAP SCALE MESHMAP=CSSMGAmmo X=1.0 Y=1.0 Z=1.0

#exec TEXTURE IMPORT NAME=MGAmmoBox FILE=Textures\AmmoParts\MGAmmo.bmp GROUP=AmmoParts LODSET=2
#exec MESHMAP SETTEXTURE MESHMAP=CSSMGAmmo NUM=0 TEXTURE=MGAmmoBox

defaultproperties
{
     AmmoAmount=50
     MaxAmmo=600
     UsedInWeaponSlot(8)=1
     PickupMessage="You picked up 50 Machine Gun Rounds."
     PickupViewMesh=SkeletalMesh'CSSWeaponsv1_1.CSSMGAmmo'
     PickupViewScale=3.100000
     MaxDesireability=0.300000
     Physics=PHYS_Falling
     LODBias=20.000000
     Mesh=SkeletalMesh'CSSWeaponsv1_1.CSSMGAmmo'
     DrawScale=3.100000
     CollisionRadius=32.000000
     CollisionHeight=8.000000
     bCollideActors=True
     RotationRate=(Yaw=0)
}