class AmmoPistols extends CSSAmmo;

#exec MESH MODELIMPORT MESH=CSSPistolAmmo MODELFILE=Models\AmmoParts\CSSPistolAmmoMesh.psk
#exec MESH ORIGIN MESH=CSSPistolAmmo X=0 Y=0 Z=0 YAW=0 PITCH=0 ROLL=0

#exec ANIM IMPORT ANIM=CSSPistolAmmoAnims ANIMFILE=Models\AmmoParts\CSSPistolAmmoMeshAnims.psa COMPRESS=1

#exec ANIM SEQUENCE ANIM=CSSPistolAmmoAnims SEQ=All STARTFRAME=0 NUMFRAMES=1
#exec ANIM SEQUENCE ANIM=CSSPistolAmmoAnims SEQ=Still STARTFRAME=0 NUMFRAMES=1

#exec ANIM DIGEST ANIM=CSSPistolAmmoAnims
#exec MESH DEFAULTANIM MESH=CSSPistolAmmo ANIM=CSSPistolAmmoAnims

#exec MESHMAP SCALE MESHMAP=CSSPistolAmmo X=1.0 Y=1.0 Z=1.0

#exec TEXTURE IMPORT NAME=DE_Handle FILE=Textures\AmmoParts\PistolAmmo.bmp GROUP=AmmoParts LODSET=2
#exec TEXTURE IMPORT NAME=DE_Shell FILE=Textures\EjectingShells\ShellCases\cssbullet1.bmp GROUP=AmmoParts LODSET=2
#exec MESHMAP SETTEXTURE MESHMAP=CSSPistolAmmo NUM=0 TEXTURE=DE_Handle
#exec MESHMAP SETTEXTURE MESHMAP=CSSPistolAmmo NUM=1 TEXTURE=DE_Shell

defaultproperties
{
     AmmoAmount=10
     MaxAmmo=150
     UsedInWeaponSlot(2)=1
     PickupMessage="You picked up 10 Pistol Rounds"
     PickupViewMesh=SkeletalMesh'CSSWeaponsv1_1.CSSPistolAmmo'
     PickupViewScale=4.100000
     MaxDesireability=0.300000
     Physics=PHYS_Falling
     LODBias=20.000000
     Mesh=SkeletalMesh'CSSWeaponsv1_1.CSSPistolAmmo'
     DrawScale=4.100000
     CollisionRadius=32.000000
     CollisionHeight=8.000000
     bCollideActors=True
     RotationRate=(Yaw=0)
}