class Grenade_FragExplosionA extends UT_FlameExplosion;

#exec AUDIO IMPORT NAME="GrenadeFragExplode" FILE=Sounds\Grenades\GrenadeFrag\FragExplode.wav GROUP="GrenadeFrag"

simulated function PostBeginPlay()
{
    MakeSound();
    Super(AnimSpriteEffect).PostBeginPlay();
}

function MakeSound()
{
    PlaySound(EffectSound1,,3.0,,2200);
}

defaultproperties
{
    EffectSound1=Sound'CSSWeaponsv1_1.GrenadeFrag.GrenadeFragExplode'
    RemoteRole=ROLE_SimulatedProxy
    LifeSpan=0.70
    NumFrames=8
    Pause=0.050000
    DrawType=DT_SpriteAnimOnce
    Style=STY_Translucent
    Texture=Texture'Botpack.UT_Explosions.Exp3_a00'
    Skin=Texture'UnrealShare.Effects.ExplosionPal'
    DrawScale=2.50
    ScaleGlow=4.00
    AmbientGlow=0
    bParticles=False
    LightType=LT_TexturePaletteOnce
    LightEffect=LE_NonIncidence
    LightBrightness=192
    LightHue=27
    LightSaturation=71
    LightRadius=9
    bCorona=False
}